package SIMYFilter;

import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import java.lang.Integer.*;
import java.util.*; 

/***************************************************************************
* SIMYFilter : YFilter Ϻκ  ¼ ¼.
* 
* @param 1 : XML  ̸.
* @param 2+ : XPath Query
* @return  
* 
* @° : XML ͸ .
* 		   ּó ؼ  ȯѴ.
* @߰ :  
* @߰2 : True | False
* 
* @author	2000160238 	
*		 	9746052		ȿ
*			2002210058	ȫ
*			2002210096	ڹ
* 
* @version 0.0.1
* @see  
*
****************************************************************************/
public class SIMYFilter extends DefaultHandler
{
	private int nspace = 4; // indentation spaces 
	private int indent = 0; // indentation level
	private boolean inTag=false; // ڽ  ġ ±  ִ ƴ Ǵϴ Boolean.
	private String[] query;
	/********************* TODO Ʈ  ؾѴ...-_-;; *********************/
	private structNFA states[] = new structNFA[8];


	
/******************************************************************
  main : SAXTest ϰ read method ҷ .
  @param args
  @throws Exception
  TODO args[1] ķ о query .
 ******************************************************************/
	public static void main(String[] args)throws Exception
	{
		if (args.length < 2)
		{
			System.out.println("[USAGE] : java SIMYfilter <filename>.xml <XPath Query>...");
			System.exit(0);
		}
		SIMYFilter simy = new SIMYFilter();
		
		System.out.println(args.length);
		System.out.println(simy.inTag);
		simy.query = new String[2];
		for(int i=0; i<(args.length - 1);i++) 
		{
			System.out.println(args[i+1]);
			simy.query[i] = new String();
			simy.query[i] = args[i+1];
			//simy.query[i] = "Dick";
		} /* arg[1]~arg[n]  query[] ѱ */
		simy.read(args[0]);
		
	}
	
/******************************************************************
  read :  ̸ ҷͼ parser ѵ, parse Ѵ.
  @param fileName
  @throws Exception
 ******************************************************************/	
	public void read(String fileName)throws Exception
	{
		SAXParserFactory factory = SAXParserFactory.newInstance();
		SAXParser parser = factory.newSAXParser();
		System.out.println();
		parser.parse(fileName,this);
	}
	
/******************************************************************
  setDocumentLocator :  ޼ҵ Locator ü ϴ ٸ ͺ  ȣǾ Ѵ. 
  @param Locator  ӵǴ ̺Ʈ ġ   ȴ
  TODO ߰ κ  ش.
 *******************************************************************/	
	public void setDocumentLocator(Locator loc)
	{
	System.out.println("[]"+loc.getSystemId());
	
	}
	
/******************************************************************
  startDocument :   ̺Ʈ Handlingϴ method.
  
  TODO Document ۽ ޾ƿ XPath  NFA . query .
 ******************************************************************/	
	public void startDocument()
	{
		System.out.println("====== ۵Ǿϴ=======");
		this.createNFA();

	}

/******************************************************************
  endDocument :   ̺Ʈ Handlingϴ method.
  TODO Ҳ .
 ******************************************************************/	
	public void endDocument()
	{
		System.out.println("====== Ǿϴ=======");
	}
	
/******************************************************************
  spaces : ĭ 
  @param int  ŭ ĭ   
  @return String  ĭ ŭ ĭ ش.
 ******************************************************************/	
	public String spaces(int num)
	{
		String str ="";
		if(num>0) 
		{
			for(int i=0;i<num;i++) str+=" ";
		}
		return str;
	
	}
	
/******************************************************************
  startElement :  Element  Handlingϴ method
  Element  , matchNFA Ѵ.
  matchNFA runtime stack ׾ִ ҵ Ѵ.
  @param uri : Namespace uri
  @param lname : localname
  @param qname : fullname
  @param atts : Attributes XML Attributes 
  TODO matchNFA ġǾٴ ּ .
 ******************************************************************/	
	public void startElement(String uri, String lname, String qname, Attributes atts)
	{
		String str = spaces(indent*nspace);
		if(inTag) System.out.println();
		System.out.print(str+"<"+qname);
		int leng = atts.getLength();
		if (leng>0)
		{
			for(int i=0; i<leng; i++) System.out.print(" "+atts.getQName(i)+"=\""+atts.getValue(i)+"\"");
		}
		System.out.print(">");
		//if (qname.equals("customer")||qname.equals("name")) { 
		// Customer ±׸ νϴ . ̺Ʈ ó
		// ⼭ XPath Ǿ оԴ string 񱳸 ϸ ȴ.
		//	System.out.println("\n !!!̰ "+qname+"  ±׷α. - ⼭ ̺Ʈ ó ϸ ǰڳ׿!!!\n");
		//}
		indent++;
		inTag=true;
	}
	
/******************************************************************
  endElement :  Element  Handlingϴ method

  @param uri : Namespace uri
  @param lname : localname
  @param qname : fullname
  TODO  Ī Element matchedElement ϰ
  		ġǸ ּ .
  TODO runtime stack ش κ .
 ******************************************************************/
	public void endElement(String uri, String lname,String qname)
	{
		System.out.println("</"+ qname + ">");
		if (qname.equals("customer")||qname.equals("name"))
		{
			// Customer ±׸ νϴ . ̺Ʈ ó
			// ⼭ XPath Ǿ оԴ string 񱳸 ϸ ȴ.
			System.out.println("!!!̰ "+qname+"  ±׷α. - ⼭ ̺Ʈ ó ϸ ǰڳ׿!!!\n");
		}
		indent--;
		inTag=false;
	}
	
/******************************************************************
  characters :  content Handlingϴ method
  @param ch :  迭
  @param start :   index
  @param length :   index
  TODO ɷ κи ְ  ߰ ɼ 
  	   ó ʿ.
 ******************************************************************/
	public void characters(char[] ch, int start, int length)
	{
		String str="";
		if(length == 0) return;
		for(int i=0;i<length;i++) 
		{
			if(ch[start+i]!= '\n') str+= ch[start+i];
		}
		str = str.trim();
		if(str !="") System.out.print(str);
	}
	
/******************************************************************
  processingInstruction : ó Handlingϴ method
  @param target : Namespace uri
  @param data : localname
  TODO Ҳ .
 ******************************************************************/

	public void processingInstruction(String target, String data)
	{
		System.out.print("\n<?"+target+" "+data+"?>");
	}
	
	
	//public void matchNFA(String element) {}
	
/********************************************************
 * createNFA : query ̿Ͽ NFA ۼѴ.
 * 
 * TODO query иϿ  tokenizing
 * TODO  token NFA ȯ
 *
 ********************************************************/
	public void createNFA() 
	{
		int stateNum = 0;			//  Ʈ ID ϱ  
		int biggestStateNum = 1;	// state ID ִ밪
		int doubleSlashFlag = 0;		//  ù state double slash̸ 1 ƴϸ 0
		
		for(int i=0; i<this.query.length; i++)
		{
			String result[]=null;
			// query[i] //  ũ¡ؼ result 迭 ִ´.
			result = this.query[i].split("//");
			
			// query //  ϴ ǴϿ flag Ѵ.
			/***************************************************
			 * doubleSlashFlag 
			 * 
			 * 0 : ù  ù Ʈ / 
			 * 1 : ù  ù Ʈ // 
			 * 2 : 
			 * 
			 ***************************************************/
			if(result[0]!= "\0")
				doubleSlashFlag = 0;
			else
				doubleSlashFlag = 1;
						
			
			/************************ 10*10   **********************/
			String finalResult[][] = new String[this.query.length][result.length];
			
			// result /  ũ¡ؼ finalResult 迭 ִ´.
			for(int j=0; j<result.length; j++)
			{
				finalResult[j] = result[j].split("/");
			}
			
			// i = 0϶ : ù XPath  -> 켱 NFA .
			if(i==0)
			{
				System.out.println(finalResult.length-1);
				// state .
				for(int j=0; j<finalResult.length-1; j++)
				{
					for(int k=1; k<finalResult[j].length; k++)
					{
						// DoubleSlash ũ¡  
						// ù ° Ҵ doubleSlashFlag ־ְ 
						//  ° ʹ 1 ־ //  ǥѴ.
						if(k==1)
						{
							if(j==0)
							{
								// ù° element : doubleSlashFlag ״ ־ش.
								// Doubleslash Flag true̸ 
								if(doubleSlashFlag == 1)
								{
									states[stateNum] = new structNFA(stateNum, 0, null, stateNum-1);
									states[stateNum].putTransition("XML", stateNum+1);
									// XML xml document "XML"̶ ڸ   Ƿ
									// ߺ ϱ Ͽ ԽǷ  Ͽ. ᱹ XML = ԽǷ ̴.
									stateNum++;
									biggestStateNum++;
									states[stateNum] = new structNFA(stateNum, 1, null, stateNum-1);
								}
								else
								{
									this.states[stateNum] = new structNFA(stateNum, 0, null, stateNum-1);
									// @author 
									//stateNum++;
									//biggestStateNum++;
									// @author  .
								}
							}
							else
							{
								// ι°ʹ doubleslash ߷Ƿ  1 ־ش.
								this.states[stateNum] = new structNFA(stateNum, 0, null, stateNum-1);
								this.states[stateNum].putTransition("XML", stateNum+1);
								stateNum++;
								biggestStateNum++;
								this.states[stateNum] = new structNFA(stateNum, 1, null, stateNum-1);
							}
						}
						//  slash ũ¡  ̹Ƿ 0 ־ش.
						else
						{
							this.states[stateNum] = new structNFA(stateNum, 0, null, stateNum-1);
						}
						
						// Transition ִ´. 
						//  ::: this.states[stateNum]  finalResult[j][k] ԷµǸ states[stateNum+1]  :::
						this.states[stateNum].putTransition(finalResult[j][k], stateNum+1);
						stateNum++;
						biggestStateNum++;
					}
				}
				
				//Final state ֱ
				this.states[stateNum] = new structNFA(stateNum, 2, null, stateNum-1);
			}
			//  °  query
			else
			{
				stateNum = 0;
				//  Ʈ ũ ŸƮ Ʈ ű.
				
				for(int j=0; j<finalResult.length; j++)
				{
					for(int k=0; k<finalResult[j].length; k++)
					{
						if((finalResult.length == j+1)&&(finalResult[j].length == k+1))
						//   Ʈ 
						{
							if(this.states[stateNum].searchTransition(finalResult[j][k]))
							// Ʈǿ  Ʈ ϴ  : 󰣴.
							{
								stateNum = this.states[stateNum].getTransition(finalResult[j][k]);
							}
							else
							// ° : ش.
							{
								this.states[stateNum].putTransition(finalResult[j][k], biggestStateNum);
								states[biggestStateNum] = new structNFA(biggestStateNum, 0, null, stateNum);
								stateNum = biggestStateNum;
								biggestStateNum++;
							}
							
							this.states[stateNum].putTypeInfo(2);
							// Final State Type Check!
						}
						else if(k==0)
						{
							if(j==0)
							//  ó 
							{
								if(doubleSlashFlag==1)
								//  ó double slash 
								{
									j++;
									if(this.states[stateNum].searchTransition("XML")==true)
									// ؽ̺ ̹ double slash  ó  ϸ
									{
										//TODO for test
										System.out.println("------------------------------");
										System.out.println(this.states[stateNum].searchTransition("XML"));
										//  Ʈ  Ʈ ũ .
										stateNum = this.states[stateNum].getTransition("XML");
										
										if(this.states[stateNum].searchTransition(finalResult[j][k]))
										// Ʈ Ʈ ϴ 
										{
											stateNum = this.states[stateNum].getTransition(finalResult[j][k]);
											//  Ʈ  Ʈ ũ .
										}
										else
										// Ʈ   ش.
										{
											this.states[stateNum].putTransition(finalResult[j][k], biggestStateNum);
											states[biggestStateNum] = new structNFA(biggestStateNum, 0, null, stateNum);
											stateNum = biggestStateNum;
											biggestStateNum++;		
										}
									}
									else
									// ƴϸ : double slash ó   
									{
										this.states[stateNum].putTransition("XML", biggestStateNum);
										// Ʈ ִ´. (ԽǷ)
										states[biggestStateNum] = new structNFA(biggestStateNum, 1, null, stateNum);
										//  Ʈ 
										stateNum = biggestStateNum;
										//  Ʈ  Ʈ ũ Ѵ.
										biggestStateNum++;
										// ִ Ʈ ѹ Ѵ.
										
										states[biggestStateNum] = new structNFA(biggestStateNum, 0, null, stateNum);
										//  Ʈ .
										this.states[stateNum].putTransition(finalResult[j][k], biggestStateNum);
										// Ʈ ߰Ѵ.(Ʈ ̸)
										stateNum = biggestStateNum;
										//  Ʈ  Ʈ ũ Ѵ.
										biggestStateNum++;
										// ִ Ʈ ѹ Ѵ.
									}
								}
								else
								//  ó double slash ƴϸ
								// Ʈ üũϰ Ѿưų Ʈ ߰Ѵ.
								{
									if(this.states[stateNum].searchTransition(finalResult[j][k]))
									// Ʈǿ Ʈ ϸ
									{
										stateNum = this.states[stateNum].getTransition(finalResult[j][k]);
									}
									else
									{
										this.states[stateNum].putTransition(finalResult[j][k], biggestStateNum);
										this.states[biggestStateNum] = new structNFA(biggestStateNum, 0, null, stateNum);
										stateNum = biggestStateNum;
										biggestStateNum++;	
									}
								}
							}
							else
							//  ù ڰ ƴϸ鼭 double slash 
							{
								this.states[stateNum].putTransition("XML", biggestStateNum);
								// Ʈ ִ´. (ԽǷ)
								states[biggestStateNum] = new structNFA(biggestStateNum, 1, null, stateNum);
								//  Ʈ 
								stateNum = biggestStateNum;
								//  Ʈ  Ʈ ũ Ѵ.
								biggestStateNum++;
								// ִ Ʈ ѹ Ѵ.
								
								states[biggestStateNum] = new structNFA(biggestStateNum, 0, null, stateNum);
								//  Ʈ .
								this.states[stateNum].putTransition(finalResult[j][k], biggestStateNum);
								// Ʈ ߰Ѵ.(Ʈ ̸)
								stateNum = biggestStateNum;
								//  Ʈ  Ʈ ũ Ѵ.
								biggestStateNum++;
								// ִ Ʈ ѹ Ѵ.
							}
						}
						else
						//     :  ǵ ƴϰ, double slash ƴ 
						{
							if(this.states[stateNum].searchTransition(finalResult[j][k]))
							// Ʈǿ Ʈ ϸ
							{
								stateNum = this.states[stateNum].getTransition(finalResult[j][k]);
							}
							else
							{
								this.states[stateNum].putTransition(finalResult[j][k], biggestStateNum);
								this.states[biggestStateNum] = new structNFA(biggestStateNum, 0, null, stateNum);
								stateNum = biggestStateNum;
								biggestStateNum++;	
							}
						}
					}
				}
			}
		}
		
		for(int i=0; i<states.length; i++) 
		{
			System.out.println("stateID : "+ states[i].stateID);
			System.out.println("type : "+ states[i].getTypeInfo());
			System.out.println("IDList : "+ states[i].getTypeInfo());
			System.out.println("Transition : \n");
			states[i].printTransition();
		}
	}
}

/**********************************************************
 * structNFA class : NFA ϳ Ʈ transition ǥ
 * 
 * @author 2000160238
 *
 * 
 * TODO typeInfo, transition, IDList ȯѴ.
 **********************************************************/
class structNFA { 
	
	//private int stateID;
	public int stateID;  //for debugging
	private int typeInfo;
	/* type
	 * 		0 : Normal
	 * 		1 : Double slash
	 * 		2 : Final state
	 * 
	 * edited by HG
	 */
	private Hashtable transition; 
	private int IDList;
	public structNFA(int id, int typeinfo, Hashtable tranSition,int parentID) 
	{
		stateID = id;
		typeInfo = typeinfo;
		transition = new Hashtable();
		if(parentID == -1)
		{
			IDList = 0;
		}
		else
		{
			IDList = parentID;
		}
	}
	public void putIDList(int idList) {IDList = idList;}
	public int getIDList() {return IDList ;}
	//TODO 
	public int getTransition(String alphabet) { 
		Integer a = (Integer)transition.get(alphabet); 
		//Object temp = (Object)a;
		return a.intValue();
		}
	public boolean searchTransition(String alphabet) { return transition.containsKey(alphabet); }
	public int getTypeInfo() { return typeInfo; }
	public void putTypeInfo(int type)
	{
		typeInfo = type;
	}
	
	// alphabet ԷµǸ nextStateNum Ѵ.
	public void putTransition(String alphabet, int nextStateNum) 
	{
		transition.put(alphabet, new Integer(nextStateNum));
	}
	//Transition θ ´.
	public void printTransition() 
	{
		Enumeration e = transition.keys();
		while(e.hasMoreElements()) 
		{
			Object xElement = e.nextElement();
			Object xTrans =  transition.get(xElement);
			System.out.println("Key = " + xElement + "	Value = " + xTrans);
		}
	}
 }



