
package snaptaxi;


/**
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.14
 * [2004.11.14.] ~ Add source.
 * [2004.11.15.] ~ Add msg inheritance.
 * [2004.11.20.] - Add constructor.
 * [2004.11.21.] - change method name from GetID() to getID()
 */
public class DisconnectMsg extends Message 
{
	// ID name who exit.
	private String id;

	public DisconnectMsg() 
	{
		id = "";
	}

	/**
	 * Set ID name who exit.
	 * Once only.
	 * @param id - ID name who exit.
	 */
	public DisconnectMsg(String id) 
	{
		this.id = id;
	}
	
	/**
	 * Check ID name who exit.
	 * @return String - ID name who exit.
	 */
	public String getID() 
	{
		return this.id;
	}
}
