
package snaptaxi;


/**
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.14
 * [2004.11.14.] ~ Add source.
 * [2004.11.15.] ~ Add msg inheritance.
 */
public class SelectMsg extends Message 
{
	private String taxiID;
	private String passengerID;
	
	public SelectMsg() 
	{
		taxiID = null;
		passengerID = null;		
	}
	
	/**
	 * @param taxiID ~ taxi ID
	 * @param passengerID ~passenger ID
	 */
	public SelectMsg(String taxiID, String passengerID) 
	{
		this.taxiID = taxiID;
		this.passengerID = passengerID;		
	}
	
	/**
	 * @return java.lang.String ~ taxi ID
	 */
	public String getTaxiID() 
	{
		return taxiID;		
	}
	
	/**
	 * @return java.lang.String ~passenger ID
	 */
	public String getPassengerID() 
	{
		return passengerID;		
	}
}
