
package snaptaxi;


/**
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.14
 * [2004.11.14.] ~ Add source.
 * [2004.11.15.] ~ Add msg inheritance.
 * [2004.11.20.] - Update Documents.
 */
public class UnregistMsg extends Message 
{
	// customer id who wants unregister.
	private String id;
	
	public UnregistMsg() 
	{
		id = "";		
	}
	
	/**
	 * Set customer id who wants unregister.
	 * @param id - customer who wants unregister.
	 */
	public UnregistMsg(String id) 
	{
		this.id = id;		
	}
	
	/**
	 * Check customer id who wants unregister.
	 * @return String - customer id who wants unregister.
	 */
	public String getID() 
	{
		return id;		
	}
}
