package snaptaxi.taxi;

import snaptaxi.*;
import javax.swing.WindowConstants;

import javax.swing.JDesktopPane;
import java.awt.BorderLayout;
import javax.swing.JTextField;
import javax.swing.JPasswordField;
import javax.swing.JLabel;
import javax.swing.JButton;
import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;


/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* *************************************
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED
* for this machine, so Jigloo or this code cannot be used legally
* for any corporate or commercial purpose.
* *************************************
*/
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
/**
 * Login Form!
 * 
 * @author SE Team#1
 * @version 1.0
 * @since [04.11.19 /ȫ] ~ Class Design
 * @since [04.11.20 /ȫ] ~ Add Coment
 * @since [04.11.20 /ȫ] ~ Implement
 * @since [04.11.20 /ȫ] ~ Modify Class Design : loginError
 * @since [04.11.21 /ȫ] ~ GUI design
 * @since [04.11.20 /ȫ] ~ Event design
 * @since [04.11.28 /ȫ] ~ Modify error
 * @since [04.11.29 /ȫ] ~ Add Join process
 * @since [04.11.29 /ȫ] ~ Add init
 * @since [04.11.30 /ȫ] ~ implement loginResult, registResult
 * @since [04.12.14 /ȫ] ~ Add more detail comment
 */
public class LoginForm extends javax.swing.JFrame
{
	
	{
		//Set Look & Feel
		try {
			javax.swing.UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	// Swing Variables
	private JDesktopPane loginFormPanel;
	private JTextField idTextField;
	private JPasswordField passTextField;
	private JLabel idLabel;
	private JLabel passLabel;
	private JLabel textLabel;
	private JButton loginButton;
	private JButton joinButton;

	private boolean idFlag = false;
	
	public LoginForm() 
	{
		super();
		initGUI();
	}
	
/*
	//TODO ׽Ʈ  ӽ÷ ۼ main
	public static void main(String[] args) {
		LoginForm inst = new LoginForm();
		inst.setVisible(true);
	}
*/
	
	/**
	 * LoginForm init!
	 * 
	 * 
	 */
	public void init() 
	{
		getidTextField().setText("");
	}
	
	/**
	 * Login to server!
	 * login information deliver to the TaxiCliet
	 * 
	 * @param id	: Taxi's id
	 * @param pass	: Taxi's password
	 */
	public void login(String id, String pass) 
	{
		if(id.length()==0 || pass.length()==0 || id.equals("user ID"))
		{
			gettextLabel().setText("Please write down your id or password");
		}
		else
		{
			TaxiClient.getTaxi().login(id, pass);
		}
	}
	
	/**
	 * Result of login!
	 * When the passenger is not registerd or password doen not matching, handle the massages  
	 * 
	 */
	public void loginResult(LoginResultMsg msg) 
	{
		// When passenger not registed
		if(msg.isNotRegist())
		{
			gettextLabel().setText("You are not registered");
		}
		// password does not matching with DB 
		else if(msg.isInvalidPass())
		{
			gettextLabel().setText("wrong password");
		}
	}

	/**
	 * join to server!
	 * join information deliver to the TaxiCliet
	 * 
	 * @param id	: Taxi's id
	 * @param pass	: Taxi's password
	 */
	public void join(String id, String pass) 
	{
		if(id.length() > 12)
		{
			gettextLabel().setText("ID is to long");
		}
		else if(id.length() < 5)
		{
			gettextLabel().setText("ID is to short");
		}
		else
		{
			TaxiClient.getTaxi().join(id, pass);
		}
	}
	
	/**
	 * Result of join!
	 * handle the Success, IDError and PWError massage
	 * 
	 */
	public void registResult(RegistResultMsg msg) 
	{
		gettextLabel().setText("exist id");
		//TODO ó
		//Success	: 
		//IDError	:
		//PWError	:
	}

	/**
	 * Init GUI Form of Login!
	 * 
	 */
	private void initGUI() {

		try {
			setSize(400, 300);
			setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
			{
				loginFormPanel = new JDesktopPane();
				this.getContentPane().add(getloginFormPanel(), BorderLayout.CENTER);
				loginFormPanel.setPreferredSize(new java.awt.Dimension(392, 309));
				{
					idTextField = new JTextField();
					loginFormPanel.add(getidTextField());
					idTextField.setText("user ID");
					idTextField.setBounds(93, 40, 191, 30);
					
					/**
					 * When Id form has focused, This event will happen!
					 * Remove text that writen in idTextField
					 * 
					 */
					idTextField.addFocusListener(new FocusAdapter() {
						public void focusGained(FocusEvent evt) {
							System.out
								.println("idTextField.focusGained, event="
									+ evt);
								if(idFlag == false)
								{
									idFlag = true;
									idTextField.setText("");
								}
						}
					});

				}
				{
					passTextField = new JPasswordField();
					loginFormPanel.add(getpassTextField());
					passTextField.setText("passTextField");
					passTextField.setBounds(95, 99, 188, 30);					

					/**
					 * When password form has focused, This event will happen!
					 * Remove text that writen in passTextField
					 * 
					 */
					passTextField.addFocusListener(new FocusAdapter() {
						public void focusGained(FocusEvent evt) {
							System.out
								.println("passTextField.focusGained, event="
									+ evt);
							passTextField.setText("");
						}
					});
				}
				{
					idLabel = new JLabel();
					loginFormPanel.add(getidLabel());
					idLabel.setText("ID");
					idLabel.setBounds(68, 39, 29, 30);
				}
				{
					passLabel = new JLabel();
					loginFormPanel.add(getpassLabel());
					passLabel.setText("PASS");
					passLabel.setBounds(55, 99, 60, 30);
				}
				{
					loginButton = new JButton();
					loginFormPanel.add(getloginButton());
					loginButton.setText("login");
					loginButton.setBounds(64, 208, 89, 30);

					/**
					 * When login button has clicked, This event will happen!
					 * Call TaxiClient's login method with id, password
					 * 
					 */
					loginButton.addMouseListener(new MouseAdapter() {
						public void mouseClicked(MouseEvent evt) {
							System.out.println("loginButton.mouseClicked, event="
								+ evt);
							login(idTextField.getText(), passTextField.getText());
						}
					});
				}
				{
					joinButton = new JButton();
					loginFormPanel.add(getjoinButton());
					joinButton.setText("join");
					joinButton.setBounds(214, 209, 79, 30);

					/**
					 * When join button has clicked, This event will happen!
					 * Call TaxiClient's join method
					 * 
					 */
					joinButton.addMouseListener(new MouseAdapter() {
						public void mouseClicked(MouseEvent evt) {
							System.out.println("joinButton.mouseClicked, event="
								+ evt);
							
							//TODO αιư    ó 
							join(idTextField.getText(), passTextField.getText());
						}
					});
				}
				{
					textLabel = new JLabel();
					loginFormPanel.add(textLabel);
					textLabel.setBounds(103, 227, 164, 30);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * getloginFormPanel
	 * 
	 * @return loginFormPanel
	 */
	public JDesktopPane getloginFormPanel() {
		return loginFormPanel;
	}
	
	/**
	 * getidTextField
	 * 
	 * @return idTextField
	 */
	public JTextField getidTextField() {
		return idTextField;
	}
	
	/**
	 * getpassTextField
	 * 
	 * @return passTextField
	 */
	public JPasswordField getpassTextField() {
		return passTextField;
	}
	
	/**
	 * getidLabel
	 * 
	 * @return idLabel
	 */
	public JLabel getidLabel() {
		return idLabel;
	}
	
	/**
	 * getpassLabel
	 * 
	 * @return passLabel
	 */
	public JLabel getpassLabel() {
		return passLabel;
	}
	
	/**
	 * gettextLabel
	 * 
	 * @return textLabel
	 */
	public JLabel gettextLabel() {
		return textLabel;
	}
	
	/**
	 * getloginButton
	 * 
	 * @return loginButton
	 */
	public JButton getloginButton() {
		return loginButton;
	}
	
	/**
	 * getjoinButton
	 * 
	 * @return joinButton
	 */
	public JButton getjoinButton() {
		return joinButton;
	}

	
}
