package snaptaxi.taxi;

/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* *************************************
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED
* for this machine, so Jigloo or this code cannot be used legally
* for any corporate or commercial purpose.
* *************************************
*/
//import java.awt.*;
import javax.swing.*;

import java.awt.BorderLayout;
import javax.swing.JButton;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.ItemEvent;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.awt.event.ItemListener;


import java.awt.Color;
import java.awt.GridLayout;
import java.awt.FlowLayout;
import javax.swing.JPanel;
import javax.swing.JDesktopPane;

//import snaptaxi.passenger.ImageCanvas;
//import snaptaxi.taxi.ImageCanvas;
import javax.swing.JLabel;
import javax.swing.ImageIcon;

import javax.swing.WindowConstants;
/**
 * Service Form!
 * 
 * @author SE Team#1
 * @version 1.0
 * @since [04.11.19 /ȫ] ~ Class Design
 * @since [04.11.20 /ȫ] ~ Add Coment
 * @since [04.11.20 /ȫ] ~ Implement default method
 * @since [04.11.22 /ȫ] ~ Design GUI
 * @since [04.11.28 /ȫ] ~ Design GUI (Con't)
 * @since [04.11.28 /ȫ] ~ Implement event
 * @since [04.11.28 /ȫ] ~ Modify event : select button, list
 * @since [04.11.29 /ȫ] ~ Modify error
 * @since [04.12.03 /ȫ] ~ Add showDetailInfo, clickPassenger
 */
public class ServiceForm extends javax.swing.JFrame
{
	private JDesktopPane jDesktopPane1;
	private JList passengerList;
	private JLabel mapLable;
	private JLabel stateLable;
	private JButton logoutButton;
	private JButton unregistButton;
	private JButton selectButton;
	private JTextArea passengerInfo;
	private JComboBox taxiState;

	private DefaultListModel passengerListModel;
	private JButton jButton4;
	private JButton jButton2;
	private JLabel jLabel1;		//Added
	private JButton jButton3;
	private JButton jButton1;
	private String jbutton1 = new String("-1");
	private String jbutton2 = new String("-1");
	private String jbutton3 = new String("-1");
	private int port1 = 0;
	private int port2 = 0;
	private int port3 = 0;
	
	private int selectNum = 0;
	
	private JDesktopPane jDesktopPane2;
	private boolean selectFlag = false;
	
	public ServiceForm() 
	{
		super();
		passengerListModel = new DefaultListModel();
		initGUI();
		getjbutton1().setVisible(false);
		getjbutton2().setVisible(false);
		getjbutton3().setVisible(false);
		changeVisible();
	}
	
	{
		//Set Look & Feel
		try {
			javax.swing.UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void inputPassenger(String passenger)
	{
		passengerListModel.addElement(passenger);
	}

	public void deletePassenger(String passenger)
	{
		passengerListModel.removeElement(passenger);
	}

	/**
	* Auto-generated main method to display this JFrame
	*/
	/*
	public static void main(String[] args) {
		ServiceForm inst = new ServiceForm();		
		inst.setVisible(true);
	}
	*/
	
	private void initGUI() {
		try {
			this.setSize(827, 516);
			this.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
			this.setFocusable(false);
			{
				jDesktopPane1 = new JDesktopPane();
				this.getContentPane().add(jDesktopPane1, BorderLayout.CENTER);
				jDesktopPane1.setPreferredSize(new java.awt.Dimension(819, 509));
				jDesktopPane1.setLayout(null);
				
				
				/******************************************************************
				 * 
				 *  The list of passenger who called taxi.
				 * 
				 *  @EVENT	: When taxi driver clicked name of passenger,
				 *  		  change passenger information panel's content.
				 * 
				 ******************************************************************/
				jDesktopPane1.setSize(414, 748);
				{
					passengerList = new JList();
					jDesktopPane1.add(getpassengerList());
					
					// ADD passenger List
					passengerListModel.addElement("*⿣ մ *");
					//passengerListModel.addElement("");
					//passengerListModel.addElement("ȫ");
					
					passengerList.setModel(passengerListModel);
					passengerList.setBounds(677, 52, 117, 290);
					passengerList
						.addListSelectionListener(new ListSelectionListener() {
						public void valueChanged(ListSelectionEvent evt) {
							System.out.println("passengerList.valueChanged, event="
								+ evt);
							//TODO 	When event occur lastIndex's value changed and that's we want to know!
							//		change passenger information panel's content with lastIndex's passenger
							
							//TODO	More implementation needs.
							Object obj = passengerList.getSelectedValue(); 
							clickPassenger(obj.toString());
						}
						});
				}

				/******************************************************************
				 * 
				 *  The combobox of taxi's state.
				 *  Can view present state, and change taxi's state.
				 * 
				 *  @EVENT	: When taxi driver changed state, 
				 * 			  Send change msg to server.
				 * 
				 ******************************************************************/
				{
					ComboBoxModel taxiStateModel = new DefaultComboBoxModel(
						new String[] { "enable", "unable" });
					taxiState = new JComboBox();
					jDesktopPane1.add(gettaxiState());
					taxiState.setModel(taxiStateModel);
					taxiState.setBounds(19, 407, 85, 30);
					taxiState.setName("select");
					taxiState.addItemListener(new ItemListener() {
						public void itemStateChanged(ItemEvent evt) {
							System.out
								.println("taxiState.itemStateChanged, event="
									+ evt);
							//TODO	When event occur item=enable's stateChange=SELECTED or DESELECTED
							// enable selected
							if(evt.getItem().toString().endsWith("enable"))
							{
								getpassengerInfo().setText("մ   ִ ");
								//changeState(1);
							}
							// unable selected
							else
							{
								getpassengerInfo().setText("մ    ");
								changeState(0);
							}
							
							//For Test : getpassengerInfo().setText(evt.getItem().toString());
						}
					});
				}

				/******************************************************************
				 * 
				 *  The Logout button.
				 * 
				 *  @EVENT	: When button has clicked, 
				 * 			  Send logout msg to server.
				 * 
				 ******************************************************************/
				{
					logoutButton = new JButton();
					jDesktopPane1.add(getlogoutButton());
					logoutButton.setText("logout");
					logoutButton.setBounds(695, 387, 88, 30);
					logoutButton.addMouseListener(new MouseAdapter() {
						public void mouseClicked(MouseEvent evt) {
							System.out.println("logoutButton.mouseClicked, event="
								+ evt);
							//TODO	send logout msg to server
							logout();
						}
					});
				}

				/******************************************************************
				 * 
				 *  The unregist button.
				 * 
				 *  @EVENT	: When button has clicked, 
				 * 			  Send unregist msg to server.
				 * 
				 ******************************************************************/
				{
					unregistButton = new JButton();
					jDesktopPane1.add(getunregistButton());
					unregistButton.setText("unregist");
					unregistButton.setBounds(694, 425, 89, 30);
					unregistButton.addMouseListener(new MouseAdapter() {
						public void mouseClicked(MouseEvent evt) {
							System.out.println("unregistButton.mouseClicked, event="
								+ evt);
							//TODO send unregist msg to server
							//inputPassenger("ڹ");
							unRegist();
						}
					});
				}

				/******************************************************************
				 * 
				 *  The Select button.
				 * 
				 *  @EVENT	: When button has clicked, 
				 * 			  Send select msg to server.
				 * 			  And change button to "UNSELECT"
				 * 			  Then clicked again, sends unselect msg.
				 * 			  Then return to select button
				 * 
				 * 			  implement tip : use selectFlag
				 * 
				 ******************************************************************/
				{
					selectButton = new JButton();
					jDesktopPane1.add(selectButton);
					selectButton.setText("select");
					selectButton.setBounds(606, 386, 72, 72);
					selectButton.addMouseListener(new MouseAdapter() {
						public void mouseClicked(MouseEvent evt) {
							System.out.println("selectButton.mouseClicked, event="
								+ evt);
							//TODO	when selectFlag == false	: send select msg to server
							//		when selectFlag == true		: send unselect msg to server
							
							if(selectFlag)
							{
								selectFlag = false;
								selectButton.setText("select");
								//unSelect();
							}
							else
							{
								selectFlag = true;
								selectButton.setText("unselect");
								
								//TODO ⿡ passengerID ޾ƿ κ ؾѴ.  ׽Ʈ 
								String passengerID = new String("TEST");
								//select(passengerID, port1);
							}
						}
					});
				}

				/******************************************************************
				 * 
				 *  The passenger information panel.
				 * 
				 *  @EVENT	: When JList(passengerList) has clicked, 
				 * 			  Show selected passenger's information
				 * 			: Implemented in JList's event.
				 * `
				 ******************************************************************/
				{
					passengerInfo = new JTextArea();
					jDesktopPane1.add(getpassengerInfo());
					passengerInfo.setText("⿡ մ");
					passengerInfo.setBounds(130, 385, 461, 75);
				}
				{
					stateLable = new JLabel();
					jDesktopPane1.add(getstateLable());
					stateLable.setText("taxi state");
					stateLable.setBounds(30, 379, 60, 30);
				}
				{
					mapLable = new JLabel();
					jDesktopPane1.add(getmapLable());
					mapLable.setText("Map");
					mapLable.setBounds(36, 20, 60, 30);
				}
				{
					//ImageCanvas IC = new ImageCanvas();
					jDesktopPane2 = new JDesktopPane();
					JLabel jLabel3 = new JLabel();
			
					jDesktopPane2.setBounds(41, 52, 591, 287);
					jLabel3.setBounds(0, 0, 591, 287);
					jDesktopPane2.setBackground(Color.LIGHT_GRAY);
					jDesktopPane2.setBounds(41, 52, 591, 287);
					jDesktopPane2.add(jLabel3);
					ImageIcon ic = new ImageIcon("map.jpg");
					jLabel3.setIcon(ic);
					//jDesktopPane2.add(IC);
					//FrameImageTest FrameMap = new FrameImageTest();
					//FrameMap.setBounds(41, 52, 591, 287);
					//FrameMap.setSize(591, 287);
					//jDesktopPane1.add(FrameMap);
					//FrameMap.setLayout(null);
					//FrameMap.setVisible(true);
					//FrameMap.makeImage("map.jpg");
					//FrameMap.setBackground(Color.LIGHT_GRAY);
					jDesktopPane1.add(jDesktopPane2);
					
					
					
					
					//jDesktopPane2.add(FrameMap);
					
					//jDesktopPane2.setBounds(41, 52, 591, 287);
					//jDesktopPane2.add(FrameMap);
					
					{
						jButton1 = new JButton();
						jLabel3.add(jButton1);
						//FrameMap.add(jButton1);
						jButton1.setBackground(Color.BLUE);
						jButton1.setText("jButton1");
						jButton1.setBounds(182, 117, 8, 8);
						//jButton1.setVisible(false);

						jButton1.addMouseListener(new MouseAdapter() {
							public void mouseClicked(MouseEvent evt) {
								System.out
									.println("jButton1.mouseClicked, event="
										+ evt);
								//TODO add your code for jButton1.mouseClicked
								if(selectNum == 1)
								{
									unSelect(jbutton1, port1);
									jButton1.setBackground(Color.BLUE);								
								}
								else
								{
									select(jbutton1, port1);
								}
							}
						});
					}
					{
						jButton2 = new JButton();
						jLabel3.add(jButton2);
						jButton2.setBackground(Color.BLUE);
						jButton2.setText("jButton2");
						jButton2.setBounds(43, 92, 8, 8);
						jButton2.addMouseListener(new MouseAdapter() {
							public void mouseClicked(MouseEvent evt) {
								System.out
									.println("jButton2.mouseClicked, event="
										+ evt);
								//TODO add your code for jButton2.mouseClicked
								//TODO add your code for jButton1.mouseClicked
								if(selectNum == 2)
								{
									unSelect(jbutton2, port2);
									jButton2.setBackground(Color.BLUE);
								}
								else
								{
									select(jbutton2, port2);
								}
							}
						});
					}
					{
						jButton3 = new JButton();
						jLabel3.add(jButton3);
						jButton3.setBackground(Color.BLUE);
						jButton3.setText("jButton3");
						jButton3.setBounds(317, 87, 8, 8);
						jButton3.addMouseListener(new MouseAdapter() {
							public void mouseClicked(MouseEvent evt) {
								System.out
									.println("jButton3.mouseClicked, event="
										+ evt);
								//TODO add your code for jButton3.mouseClicked
								//TODO add your code for jButton1.mouseClicked
								if(selectNum == 3)
								{
									unSelect(jbutton3, port3);
									jButton3.setBackground(Color.BLUE);
								}
								else
								{
									select(jbutton3, port3);
								}
							}
						});
					}
					{
						jButton4 = new JButton();
						jLabel3.add(jButton4);
						jButton4.setBackground(Color.BLACK);
						jButton4.setText("jButton4");
						jButton4.setBounds(262, 139, 18, 10);
					}
					{/*
						jLabel1 = new JLabel();
			 			jDesktopPane2.add(jLabel1);
						jLabel1.setIcon(new ImageIcon(getClass()
							.getClassLoader().getResource("map.jpg")));
						jLabel1.setBounds(0, 0, 591, 287);*/
					}
					{
					//Added
					/*
						jLabel1 = new JLabel();
			 			jDesktopPane2.add(jLabel1);
						jLabel1.setIcon(new ImageIcon(getClass()
							.getClassLoader().getResource("map.jpg")));
						jLabel1.setBounds(0, 0, 591, 287);*/
					}
				}

			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public JDesktopPane getJDesktopPane1() {
		return jDesktopPane1;
	}
	
	public JList getpassengerList() {
		return passengerList;
	}
		

	public JButton getjbutton1() {
		return jButton1;
	}

	public JButton getjbutton2() {
		return jButton2;
	}

	public JButton getjbutton3() {
		return jButton3;
	}

	public JComboBox gettaxiState() {
		return taxiState;
	}
	
	public JButton getlogoutButton() {
		return logoutButton;
	}
	
	public JButton getunregistButton() {
		return unregistButton;
	}
	public JTextArea getpassengerInfo() {
		return passengerInfo;
	}
	
	public JLabel getstateLable() {
		return stateLable;
	}
	
	public JLabel getmapLable() {
		return mapLable;
	}
	
	/******************************************************
	 * 
	 *  End of GUI
	 *
	 ******************************************************/
	
	
	
	
	
	
	
	
	/**
	 * logout!
	 * 
	 */
	public void logout() 
	{
		TaxiClient.getTaxi().logout();
	}
	
	/**
	 * UnRegist Taxi's information!
	 * 
	 */
	public void unRegist() 
	{
		TaxiClient.getTaxi().unRegist();
	}
	
	/**
	 * call from passenger!
	 *
	 * @param passengerID	: id of selected person 
	 * @param posX			: x position of passenger
	 * @param posY			: y positioin of passenger
	 */
	public void call(String passengerID, int posX, int posY, int port) 
	{
		inputPassenger(passengerID);

		if(jbutton1.equals("-1"))
		{
			jbutton1 = passengerID;
			getjbutton1().setBounds(posX, posY, 18, 10);
			getjbutton1().setVisible(true);
			port1 = port;
		}
		else if(jbutton2.equals("-1"))
		{
			jbutton2 = passengerID;
			getjbutton2().setBounds(posX, posY, 18, 10);
			getjbutton2().setVisible(true);
			port2 = port;
		}
		else if(jbutton3.equals("-1"))
		{
			jbutton3 = passengerID;
			getjbutton3().setBounds(posX, posY, 18, 10);
			getjbutton3().setVisible(true);
			port3 = port;
		}

		getpassengerInfo().setText(passengerID + " մ ȣϿϴ.");
	}
	
	/**
	 * cancel call from passenger!
	 *
	 * @param passengerID	: id of selected person 
	 */
	public void cancelCall(String passengerID) 
	{
		deletePassenger(passengerID);

		if(jbutton1.equals(passengerID))
		{
			jbutton1 = "-1";
			getjbutton1().setBackground(Color.BLUE);
			getjbutton1().setVisible(false);
		}
		else if(jbutton2.equals(passengerID))
		{
			jbutton2 = "-1";
			getjbutton2().setBackground(Color.BLUE);
			getjbutton2().setVisible(false);
		}
		else if(jbutton3.equals(passengerID))
		{
			jbutton3 = "-1";
			getjbutton3().setBackground(Color.BLUE);
			getjbutton3().setVisible(false);
		}
		
		selectNum = 0;

		getpassengerInfo().setText(passengerID + " մ ȣ ҵǾϴ.");
	}
	
	/**
	 * Select passenger!
	 *
	 * @param passengerID	: id of selected person 
	 */
	public void select(String passengerID, int port) 
	{
		if(selectNum == 1)
		{
			unSelect(jbutton1, port1);
		}
		else if(selectNum == 2)
		{
			unSelect(jbutton2, port2);
		}
		else if(selectNum == 3)
		{
			unSelect(jbutton3, port3);
		}

		if(jbutton1.equals(passengerID))
		{
			jButton1.setBackground(Color.RED);
			jButton2.setBackground(Color.BLUE);
			jButton3.setBackground(Color.BLUE);
			
			selectNum = 1;
		}
		else if(jbutton2.equals(passengerID))
		{
			jButton2.setBackground(Color.RED);
			jButton1.setBackground(Color.BLUE);
			jButton3.setBackground(Color.BLUE);
			
			selectNum = 2;
		}
		else if(jbutton3.equals(passengerID))
		{
			jButton3.setBackground(Color.RED);
			jButton2.setBackground(Color.BLUE);
			jButton1.setBackground(Color.BLUE);
			
			selectNum = 3;
		}

		TaxiClient.getTaxi().select(passengerID, port);
		getpassengerInfo().setText(passengerID + " մ Ͽϴ.");
	}
	
	/**
	 * UnSelect passenger!
	 * 
	 * @param id	: Taxi's id
	 * @param pass	: Taxi's password
	 */
	public void unSelect(String passengerID, int port) 
	{
		TaxiClient.getTaxi().unSelect(passengerID, port);
		getpassengerInfo().setText(passengerID + " մ԰  ϴ.");
		
		selectNum = 0;
	}
	
	/**
	 * Change Taxi's state!
	 * state	0 : Can service
	 * 			1 : Can't service
	 *
	 */
	public void changeState(int state) 
	{
		TaxiClient.getTaxi().changeState(state);
	}
	
	/**
	 * When driver clicked passenger which placed in list.
	 * Show detail information of passenger in textArea
	 *
	 */
	public void clickPassenger(String id)
	{
		TaxiClient.getTaxi().clickPassenger(id);
	}

	/**
	 * When driver clicked passenger which placed in list.
	 * Show detail information of passenger in textArea
	 *
	 */
	public void showDetailInfo(String id)
	{
		getpassengerInfo().setText(id);
	}
	
	public void changeVisible()
	{
		getjbutton1().setBounds(271, 203, 18, 10);
	}
}
