
package snaptaxi;


/**
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.14
 * [2004.11.14.] ~ Add source.
 * [2004.11.15.] ~ Message inheritance addition.
 */
public class CallMsg extends Message 
{
	private int posX;
	private int posY;
	private String passengerID;
	
	public CallMsg() 
	{
		this.posX = 0;
		this.posY = 0;
		this.passengerID = "";		
	}
	
	/**
	 * @param passengerID
	 * @param posX
	 * @param posY
	 */
	public CallMsg(String passengerID, int posX, int posY) 
	{
		this.posX = posX;
		this.posY = posY;
		this.passengerID = passengerID;		
	}
	
	/**
	 * @return java.lang.String
	 */
	public String getPassengerID() 
	{
		return this.passengerID;		
	}
	
	/**
	 * @return int
	 */
	public int getPosX() 
	{
		return  this.posX;		
	}
	
	/**
	 * @return int
	 */
	public int getPosY() 
	{
		return  this.posY;		
	}
}
