
package snaptaxi;


/**
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.14
 * [2004.11.14.] ~ Add source.
 * [2004.11.15.] ~ Add msg inheritance.
 */
public class GPSPositionMsg extends Message 
{
	private int posX;
	private int posY;
	private String id;
	
	public GPSPositionMsg() 
	{
		posX = 0;
		posY = 0;
		id	 = null;		
	}
	
	/**
	 * @param id
	 * @param posX
	 * @param posY
	 */
	public GPSPositionMsg(String id, int posX, int posY) 
	{
		this.id = id;
		this.posX = posX;
		this.posY = posY;		
	}
	
	/**
	 * @return java.lang.String ~ receive id
	 */
	public String getID() 
	{
		return id;		
	}
	
	/**
	 * @return int ~point x
	 */
	public int getPosX() 
	{
		return posX;		
	}
	
	/**
	 * @return int ~point y
	 */
	public int getPosY() 
	{
		return posY;		
	}
}
