
package snaptaxi;


/**
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.14
 * [2004.11.14.] ~ Add source.
 * [2004.11.15.] ~ Add msg inheritance.
 * [2004.11.29.] ~ Add msg extends Message in class
 */
public class LoginMsg extends Message
{
	private String id;
	private String pass;
	
	public LoginMsg() 
	{
		id = "";
		pass = "";		
	}
	
	/**
	 * @param id
	 * @param pass
	 */
	public LoginMsg(String id, String pass) 
	{
		this.id = id;
		this.pass = pass;		
	}
	
	/**
	 * @return java.lang.String ~ID
	 */
	public String getID() 
	{
		return id;		
	}
	
	/**
	 * @return java.lang.String ~password
	 */
	public String getPass() 
	{
		return pass;		
	}
}
