package snaptaxi.passenger;

import java.awt.Canvas;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import com.sun.media.sound.Toolkit;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

class ImageCanvas extends Canvas {
	
	private int posX;
	private int posY;
	private int width;
	private int height;
	private int widthX;
	private int heightY;
	private Image image = null;
	
	public ImageCanvas()  {
	   	
	       image = getToolkit().getImage("map.jpg");

	       MediaTracker tracker = new MediaTracker(this);

	       tracker.addImage(image, 0);

	       try{

	          tracker.waitForID(0);

	       }catch(Exception e){}

	       width = image.getWidth(this);
	       height = image.getHeight(this);
	       widthX = width/2;
	       heightY = height/2;
	       
	       this.setSize(230,289);
	       this.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent evt) {
				posX = evt.getX();
				posY = evt.getY();
				posX = posX+widthX-115;
				posY = posY+heightY-144;
				widthX = posX;
				heightY = posY;
				repaint();
			}
		});

	   }

	   public void paint(Graphics g)   {
	       
	       g.drawImage(image, 0, 0, 230, 289, widthX-115, heightY-144, widthX+115, heightY+144, this);

	   }
	   public int getX()
	   {
	   	return posX;
	   }
	   
	   public int getY()
	   {
	   	return posY;
	   }
	}