
package snaptaxi.passenger;

import javax.swing.WindowConstants;


/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* *************************************
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED
* for this machine, so Jigloo or this code cannot be used legally
* for any corporate or commercial purpose.
* *************************************
*/

import javax.swing.JDesktopPane;
import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JButton;
/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* *************************************
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED
* for this machine, so Jigloo or this code cannot be used legally
* for any corporate or commercial purpose.
* *************************************
*/
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.SwingConstants;
/**
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.20
 * [2004.11.20./] ~ Add source.
 * [2004.11.29./] ~ Add GUI design.
 * [2004.11.29./] ~ Delete code that display image.
 * [2004.11.29./] ~ Change architecture. - Class FindLocation is not used. =_=
 * [2004.11.29./] ~ Event design.
 * [2004.11.29./] ~ Add lock flag and code.
 * [2004.11.30./] ~ Implementation reaction of SelectResultMsg.
 * 
 * TODO Image 
 */
public class TaxiCall extends javax.swing.JFrame
{
	String id;
	int posX, posY;
	int eCoin;
	
	{
		//Set Look & Feel
		try {
			javax.swing.UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	private ImageCanvas ic;
	private JDesktopPane jDesktopPane1;
	private JPanel Map;
	private JLabel Satus2;
	private JButton jButton2;
	private JLabel statusEcoin;
	private JLabel statusId;
	private JLabel statusPos;
	private JButton jButton4;
	private JButton jButton3;
	private JLabel map;
	private JLabel Status3;
	private JLabel Status1;
	private JButton jButton1;
	private JLabel jLabel1;
	private boolean unlocked;
	private boolean cancelUnlocked;
	
	/**
	 * Constructor with parameter id
	 */
	public TaxiCall(String id) 
	{
		super();
		this.id = id;
		unlocked = true;
		cancelUnlocked = false;
		ic = new ImageCanvas();
		initGUI();
	}
	
	/**
	 * Cancel connect
	 */
	public void cancelConnect()
	{
		unlocked = true;
		cancelUnlocked = false;
		jLabel1.setText("ý ȣ  - ø ٷּ...");
		jButton3.setEnabled(false);
		jButton4.setEnabled(false);
		Map.setEnabled(false);
		jButton1.setEnabled(false);
		jButton2.setEnabled(false);
		unlocked = false;
	}
	
	/**
	* Main method for test
	*/
	public static void main(String[] args) {
		TaxiCall inst = new TaxiCall("test");
		inst.setVisible(true);
	}
	
	/**
	 * Taxicall is successed.
	 * Show success message.
	 */
	
	public void successTaxiCall()
	{
		unlocked = false;
		cancelUnlocked = true;
		jLabel1.setText("ý ȣ⿡ ߽ϴ!!");
		jButton3.setEnabled(false);
		jButton4.setEnabled(false);
		Map.setEnabled(false);
		jButton1.setEnabled(false);
		jButton2.setEnabled(true);
	}
	
	/**
	 * Taxicall is failed.
	 * Show fail message.
	 */
	public void failTaxiCall()
	{
		unlocked = true;
		cancelUnlocked = false;
		jLabel1.setText("!! - ٽ õϼ.");
		jButton3.setEnabled(true);
		jButton4.setEnabled(true);
		Map.setEnabled(true);
		jButton1.setEnabled(true);
		jButton2.setEnabled(false);
	}
	
	/**
	 * during taxi calling, error is occured.
	 * Show error message.
	 */
	public void errorOccured()
	{
		unlocked = true;
		cancelUnlocked = false;
		jLabel1.setText("Error!! - ٽ õϼ.");
		jButton3.setEnabled(true);
		jButton4.setEnabled(true);
		Map.setEnabled(true);
		jButton1.setEnabled(true);
		jButton2.setEnabled(false);
	}
	
	/**
	 * Make GUI for Taxicall.
	 * Add swing component to jDesktopPane
	 */
	private void initGUI() {
		try {
			this.setSize(350, 417);
			setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
			{
				jDesktopPane1 = new JDesktopPane();
				this.getContentPane().add(jDesktopPane1, BorderLayout.CENTER);
				jDesktopPane1.setPreferredSize(new java.awt.Dimension(337, 385));
				{
					Map = new JPanel();
					jDesktopPane1.add(Map);
					Map.add(ic);
					Map.setBounds(9, 9, 230, 289);
					Map.setPreferredSize(new java.awt.Dimension(10, 0));
					ic.addMouseListener(new MouseAdapter() {
						public void mouseClicked(MouseEvent evt) {
							if(unlocked)
							{
								posX = ic.getX();
								posY = ic.getY();
								statusPos.setText("("+ic.getX()+","+ic.getY()+")");
							}
						}
					});
					// Draw Image
					/*{
						map = new JLabel();
						Map.add(map);
						map.setIcon(new ImageIcon(getClass().getClassLoader()
							.getResource("3-rose2195.jpg")));
						map.setBounds(644, 339, 60, 30);
					}*/
				}
				{
					jLabel1 = new JLabel();
					jDesktopPane1.add(jLabel1);
					jLabel1.setText(" ġ Ŭ ּ.");
					jLabel1.setBounds(12, 306, 225, 30);
					jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
				}
				{
					jButton1 = new JButton();
					jDesktopPane1.add(jButton1);
					jButton1.setText("Snap It!");
					jButton1.setBounds(21, 343, 86, 24);
					jButton1.addMouseListener(new MouseAdapter() {
						public void mouseClicked(MouseEvent evt) {
							if(unlocked)
							{
								PassengerClient.getPassenger().taxiCall(posX, posY);
								jLabel1.setText("ý ȣ  - ø ٷּ...");
								jButton3.setEnabled(false);
								jButton4.setEnabled(false);
								Map.setEnabled(false);
								jButton1.setEnabled(false);
								unlocked = false;
							}
						}
					});
				}
				{
					Status1 = new JLabel();
					jDesktopPane1.add(Status1);
					Status1.setText("ID :");
					Status1.setBounds(248, 114, 76, 16);
				}
				{
					Satus2 = new JLabel();
					jDesktopPane1.add(Satus2);
					Satus2.setText("Location :");
					Satus2.setBounds(248, 164, 74, 19);
				}
				{
					Status3 = new JLabel();
					jDesktopPane1.add(Status3);
					Status3.setText("E-Coin :");
					Status3.setBounds(248, 218, 74, 18);
				}
				{
					jButton2 = new JButton();
					jDesktopPane1.add(jButton2);
					jButton2.setText("Cancel");
					jButton2.setBounds(133, 343, 86, 24);
					jButton2.setEnabled(false);
					jButton2.addMouseListener(new MouseAdapter() {
						public void mouseClicked(MouseEvent evt) {
							if(cancelUnlocked)
							{
								jLabel1.setText("ȣ   - ø ٷּ...");
								PassengerClient.getPassenger().cancelTaxiCall(id);
								jLabel1.setText("ҵǾϴ.");
								jButton3.setEnabled(true);
								jButton4.setEnabled(true);
								Map.setEnabled(true);
								jButton1.setEnabled(true);
								jButton2.setEnabled(false);
								unlocked = true;
							}
						}
					});
				}
				{
					jButton3 = new JButton();
					jDesktopPane1.add(jButton3);
					jButton3.setText("Logout");
					jButton3.setBounds(250, 12, 78, 30);
					jButton3.addMouseListener(new MouseAdapter() {
						public void mouseClicked(MouseEvent evt) {
							if(unlocked)
							{
								PassengerClient.getPassenger().logout(id);
							}
						}
					});
				}
				{
					jButton4 = new JButton();
					jDesktopPane1.add(jButton4);
					jButton4.setText("Unregist");
					jButton4.setBounds(250, 54, 78, 30);
					jButton4.setMargin(new java.awt.Insets(2, 2, 2, 2));
					jButton4.addMouseListener(new MouseAdapter() {
						public void mouseClicked(MouseEvent evt) {
							if(unlocked)
							{
								PassengerClient.getPassenger().unregister(id);
							}
						}
					});
				}
				{
					statusPos = new JLabel();
					jDesktopPane1.add(statusPos);
					statusPos.setText("("+posX+","+posY+")");
					statusPos.setBounds(247, 181, 78, 17);
				}
				{
					statusId = new JLabel();
					jDesktopPane1.add(statusId);
					statusId.setText(id);
					statusId.setBounds(247, 132, 79, 16);
				}
				{
					statusEcoin = new JLabel();
					jDesktopPane1.add(statusEcoin);
					statusEcoin.setText(eCoin+" Won");
					statusEcoin.setBounds(248, 240, 62, 11);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
