//Source file: C:\\temp\\snaptaxi.client\\NetClient.java

package snaptaxi.taxi;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.DatagramPacket;
import java.net.DatagramSocket;

import snaptaxi.*;


/**
 * Networking with server client!
 * 
 * @author SE Team#1
 * @version 1.0
 * @since [04.11.19 /ȫ] ~ Class Design
 * @since [04.11.20 /ȫ] ~ Add Coment
 * [04.11.20 ] ~ Implementation Complete
 * [04.11.29 ȫ] ~ delete select msg
 * [04.12.14 /ȫ] ~ Add more detail comment
 * 
 */
public class NetClient extends Thread 
{
	TaxiListener listener;

	DatagramSocket socket=null;
    DatagramPacket packetOut=null, packetIn=null;
    byte inputB[] = new byte[1024];
    
    public NetClient() 
	{
    	this.listener = new TaxiListener(); 
		
	    // Initialize sockect and open.
    	// Because of Client, We don't have to choose the port.
	       try {

	          socket = new DatagramSocket(2230); 
	          System.out.println("Flag for Network1 : ");
	       }
	       catch(IOException e){

		          System.out.println("Failure: "+e);

		   }
   }
	

	/**
	 * Receive mesage from server!
	 * 
	 */
	public void run() 
	{
		// Make ObjectOutputStream & ByteArrayOutputStream.
		// also, Receive Packet from network.
		// make messages to Object stream.
		// & get class name from Object stream.
		for(;;) {
			try {
				int len = inputB.length;
				packetIn = new DatagramPacket(inputB, len);
				System.out.println("Flag for Network2 : ");
		        socket.receive(packetIn);
		        //Receive Packet from network.
		        
		        
		        ByteArrayInputStream inputBuf = new ByteArrayInputStream(inputB);
		        ObjectInputStream inputObj = new ObjectInputStream(inputBuf);
		        //Make ObjectOutputStream & ByteArrayOutputStream.
		        Object packet = inputObj.readObject();
		        System.out.println("Flag for Network3 : "+packet.getClass().getName());
		        if(packet.getClass().getName() == "snaptaxi.LoginResultMsg") {
		        	// if Class name is LoginResultMsg, Regist Object to the listener.
		        	this.listener.onLoginResult(
		        			new Address(packetIn.getAddress(), packetIn.getPort()),
							(LoginResultMsg) packet);
		        }
		        else if(packet.getClass().getName() == "snaptaxi.SelectMsg") {
		        	// if Class name is SelectMsg, Regist Object to the listener.
/* TODO ʿ   ؼ ּ
		        	this.listener.onSelect(
		        			new Address(packetIn.getAddress(), packetIn.getPort()),
							(SelectMsg) inputObj.readObject());
*/
		        		        }
		        else if(packet.getClass().getName() == "snaptaxi.SelectResultMsg") {
		        	// if Class name is SelectResultMsg, Regist Object to the listener.
		        	this.listener.onSelectResult(
		        			new Address(packetIn.getAddress(), packetIn.getPort()),
							(SelectResultMsg) packet);
		        }
		        else if(packet.getClass().getName() == "snaptaxi.CallMsg") {
		        	// if Class name is CallMsg, Regist Object to the listener.
		        	System.out.println("Flag for Network4 : ");
		        	this.listener.onCall(
		        			new Address(packetIn.getAddress(), packetIn.getPort()),
							(CallMsg) packet);
		        }
		        else if(packet.getClass().getName() == "snaptaxi.CancelCallMsg") {
		        	// if Class name is CancelCallMsg, Regist Object to the listener.
		        	this.listener.onCancelCall(
		        			new Address(packetIn.getAddress(), packetIn.getPort()),
							(CancelCallMsg) packet);
		        }
		        else if(packet.getClass().getName() == "snaptaxi.GPSPositionMsg") {
		        	// if Class name is GPSPositionMsg, Regist Object to the listener.
		        	this.listener.onGPSPosition(
		        			new Address(packetIn.getAddress(), packetIn.getPort()),
							(GPSPositionMsg) packet);
		        }
			} catch (IOException i){ // do nothing if it has the IOException -_-
				
			} catch (ClassNotFoundException c){// do nothing if it has ClassNotFound ALSO -_-v
											   // cause it's BULLSHIT LIKE YOU -_-b
			}
		}
	}
	
	/**
	 * Send message to server!
	 * 
	 */
	public void sendMessage(Address address, Message msg,int port)
	{
		try {
			ByteArrayOutputStream outputBuf = new ByteArrayOutputStream();
	        ObjectOutputStream outputObj = new ObjectOutputStream(outputBuf);   
	        //Create ByteArrayOutputStream & ObjectOutputStream.
	        
	        outputObj.writeObject(msg);
	        //Write Message Object to ObjectOutputStream.
	        //Actually, those Object will be written in outputbuf.
	        	        
	        packetOut = new DatagramPacket(
	        		outputBuf.toByteArray(), outputBuf.size(),
					address.getIP(), port);
	        //Create Packet from information of ObjectOutputStream & Address Object.
	        socket.send(packetOut); 
	        System.out.println("Flag for NetworkSend : "+msg.getClass().getName());
	        System.out.println("port : "+port);
	        outputObj.close();
	        outputBuf.close();
	        //Close It.
		} catch(IOException i){// do nothing if it has IOException -_-v
			                   // cause it's BULLSHIT LIKE YOU -_-b
			
		}
	}
}
